import java.util.*;
class Tuple {
	ArrayList<Tuple> tuples;
	
	public Tuple() {
		tuples = new ArrayList<Tuple>();
	}
	
	public void add(Tuple t) {
		this.tuples.add(t);
	}
	
	public Tuple append(Tuple t) {
		Tuple tt = new Tuple();
		tt.add(this);
		tt.add(t);
		return tt;
	}
	
	public String toString() {
		String s = "";
		for (int i = 0; i < this.tuples.size(); i++) {
			s += tuples.get(i) + ", ";
		}
		if (s.length() > 2) {
			s = s.substring(0, s.length() - 2);
		}
		if (s.equals("")) {
			return "0";
		}
		return "<" + s + ">";
	}
	
	public int arity() {
		return this.tuples.size();
	}
	
	public int depth() {
		int n = 0;
		if (this.arity() == 0) {
			return n;
		}
		for (int i = 0; i < this.tuples.size(); i++) {
			if (n < this.tuples.get(i).depth()) {
				n = this.tuples.get(i).depth();
			}
		}
		return n + 1;
	}
}
